#include <RobotAPI/libraries/armem/client/WriterComponentPlugin.h>


// ArmarX
#include <ArmarXCore/core/Component.h>
#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

// RobotAPI
#include <RobotAPI/libraries/armem/core/error.h>


namespace armarx::armem::client::plugins
{
    WriterComponentPlugin::WriterComponentPlugin(ManagedIceObject& parent, std::string pre) :
        ComponentPlugin(parent, pre)
    {
        addPlugin(mnsPlugin, pre);
        addPluginDependency(mnsPlugin);
    }

    WriterComponentPlugin::~WriterComponentPlugin()
    {
    }
}


namespace armarx::armem::client
{
    WriterComponentPluginUser::WriterComponentPluginUser()
    {
        addPlugin(plugin);
    }


    WriterComponentPluginUser::~WriterComponentPluginUser()
    {
        // pass
    }


    void
    WriterComponentPluginUser::setWritingMemoryServer(server::WritingMemoryInterfacePrx memory)
    {
        memoryWriter.setWritingMemory(memory);
    }


    armem::data::WaitForMemoryResult WriterComponentPluginUser::useMemoryServer(const std::string& memoryName)
    {
        armem::data::WaitForMemoryResult result;
        result.proxy = memoryNameSystem.useServer(MemoryID().withMemoryName(memoryName));
        if (result.proxy)
        {
            setWritingMemoryServer(result.proxy);
        }
        return result;
    }
}

