#pragma once

#include <RobotAPI/libraries/armem/core/forward_declarations.h>
#include <RobotAPI/libraries/armem/core/base/detail/derived.h>

#include <RobotAPI/libraries/aron/core/navigator/data/forward_declarations.h>

#include <optional>


namespace armarx::armem::wm::detail
{
    using base::detail::derived;


    template <class DerivedT>
    struct FindInstanceDataMixin
    {
        aron::datanavigator::DictNavigatorPtr
        findLatestInstanceData(const MemoryID& entityID, int instanceIndex = 0) const
        {
            const auto* instance = derived<DerivedT>(this).findLatestInstance(entityID, instanceIndex);
            return instance ? instance->data() : nullptr;
        }


        template <class AronDtoT>
        std::optional<AronDtoT>
        findLatestInstanceDataAs(const MemoryID& entityID, int instanceIndex = 0) const
        {
            if (aron::datanavigator::DictNavigatorPtr data = derived<DerivedT>(this).findLatestInstanceData(entityID, instanceIndex))
            {
                AronDtoT aron;
                aron.fromAron(data);
                return aron;
            }
            else
            {
                return std::nullopt;
            }
        }

    };

}
