#include "MemoryControlWidget.h"

#include <QPushButton>
#include <QLineEdit>
#include <QTimer>
#include <QHBoxLayout>
#include <QFileDialog>

#include <cmath>


namespace armarx::armem::gui
{

    MemoryControlWidget::MemoryControlWidget()
    {
        setSizePolicy(QSizePolicy::Policy::Minimum, QSizePolicy::Policy::Fixed);

        auto vlayout = new QVBoxLayout();
        auto hlayout1 = new QHBoxLayout();
        auto hlayout2 = new QHBoxLayout();

        hlayout1->setContentsMargins(10, 2, 10, 2);
        hlayout2->setContentsMargins(10, 2, 10, 2);

        const int margin = 0;
        vlayout->setContentsMargins(margin, margin, margin, margin);

        _lineEdit = new QLineEdit("/tmp/MemoryExport", this);
        //_lineEdit->setSizePolicy(QSizePolicy::Ignored, QSizePolicy::Preferred);

        _openFileBrowserButton = new QPushButton("Search files", this);

        _storeOnDiskButton = new QPushButton("Store", this);
        _loadFromDiskButton = new QPushButton("Load", this);

        hlayout1->addWidget(_lineEdit);
        hlayout1->addWidget(_openFileBrowserButton);

        hlayout2->addWidget(_storeOnDiskButton);
        hlayout2->addWidget(_loadFromDiskButton);

        vlayout->addItem(hlayout1);
        vlayout->addItem(hlayout2);

        this->setLayout(vlayout);
        // Private connections.

        // Public connections.
        connect(_openFileBrowserButton, &QPushButton::pressed, this, &This::openFileBrowser);
        connect(_loadFromDiskButton, &QPushButton::pressed, this, &This::loadFromDisk);
        connect(_storeOnDiskButton, &QPushButton::pressed, this, &This::storeOnDisk);
    }

    void MemoryControlWidget::openFileBrowser()
    {
        QFileDialog dialog;
        dialog.setFileMode(QFileDialog::DirectoryOnly);
        //dialog.setOption(QFileDialog::DontUseNativeDialog, true);
        dialog.setOption(QFileDialog::ShowDirsOnly, false);
        dialog.exec();
        QString open = dialog.directory().path();
        _lineEdit->setText(open);
    }

    QString MemoryControlWidget::getEnteredPath()
    {
        return _lineEdit->text();
    }
}

